export interface LevelDesc {
    importance: number;
    sym: string;
    desc: string;
}
export interface Msg {
    color?: string[];
    lf?: string;
    maxLen?: number;
}
export declare class Log {
    protected static readonly defDateFormat = "%YYYY%MM%DD %hh:%mm:%ss.%jjj";
    static readonly DEBUG = "DEBUG";
    static readonly INFO = "INFO";
    static readonly WARN = "WARN";
    static readonly ERROR = "ERROR";
    static readonly transientLength = 120;
    protected static INDENT_COLORS: string[];
    protected static dateFormat: string;
    protected static levels: {
        DEBUG: {
            importance: number;
            sym: string;
            desc: string;
        };
        INFO: {
            importance: number;
            sym: string;
            desc: string;
        };
        WARN: {
            importance: number;
            sym: string;
            desc: string;
        };
        ERROR: {
            importance: number;
            sym: string;
            desc: string;
        };
    };
    protected static colors: boolean;
    protected static maxLength: number;
    static log: Log;
    protected static globalLog(L: typeof Log): Log;
    protected static globalLevel: LevelDesc;
    protected reportLevel: LevelDesc;
    protected reportPrefix: string;
    protected local: boolean;
    constructor(prefix: string);
    set messageLength(max: number);
    get messageLength(): number;
    level(newLevelSym?: string, setGlobalLevel?: boolean): string;
    debug(...msgs: any[]): string;
    transient(...msgs: any[]): string;
    progress(...msgs: any[]): string;
    info(...msgs: any[]): string;
    warn(...msgs: any[]): string;
    error(...msgs: any[]): string;
    protected out(lvl: string, msg: any | any[], options: Msg): string;
    protected output(options: Msg, headerParts: string[], line: string): void;
    protected limitLength(line: string, maxLen: number): string[];
    format(fmtStr?: string): string;
    prefix(prf?: string): string;
    config(cfg: {
        colors?: boolean;
        format?: string;
        level?: string;
    }): void;
    inspect(msg: any, { depth, indent, colors }?: {
        depth?: number;
        indent?: string;
        colors?: string[];
    }): string;
    protected getPrePostfix(indent: string, level: number, currIndent: string, colors: string[]): [string, string, string, string];
}
